/* 
 * Author: Jan Odvarko, www.janodvarko.cz
 */

FBL.ns(function() { with (FBL) 
{ 

var panelName = "HelloWorld";

/**
 * Localization helpers
 */
function $HW_STR(name)
{
    return document.getElementById("strings_helloWorld").getString(name);
}

function $HW_STRF(name, args)
{
    return document.getElementById("strings_helloWorld").getFormattedString(name, args);
}

/**
 * Model implementation.
 */
Firebug.HelloWorldModel = extend(Firebug.Module, 
{ 
    showPanel: function(browser, panel) 
    { 
        var isHwPanel = panel && panel.name == panelName; 
        var hwButtons = browser.chrome.$("fbHelloWorldButtons"); 
        collapse(hwButtons, !isHwPanel); 
    },

    onMyButton: function(context) 
    {
        var panel = context.getPanel(panelName);        
        var args = {
            date: (new Date()).toGMTString(),
        };
        helloWorldRep.myTag.append(args, panel.panelNode, helloWorldRep);
    }
}); 

/**
 * Panel implementation
 */
function HelloWorldPanel() {} 
HelloWorldPanel.prototype = extend(Firebug.Panel, 
{ 
    name: panelName, 
    title: $HW_STR("helloworld.paneltitle"), 

    initialize: function() 
    {
        Firebug.Panel.initialize.apply(this, arguments);
    },
    
    getOptionsMenuItems: function(context)
    {
        return [
            this.optionMenu($HW_STR("helloworld.option1"), "helloworld.option1"),
            "-",
            this.optionMenu($HW_STR("helloworld.option2"), "helloworld.option2")
        ];
    },

    optionMenu: function(label, option)
    {
        var value = Firebug.getPref(Firebug.prefDomain, option);
        return { 
            label: label, 
            nol10n: true, 
            type: "checkbox", 
            checked: value, 
            command: bindFixed(Firebug.setPref, this, Firebug.prefDomain, option, !value) 
        };
    }
}); 

/**
 * Hello World domplate
 */
var helloWorldRep = domplate(
{
    date: (new Date()).toGMTString(),

    myTag:
        DIV({class: "MyDiv", onclick: "$onClick"}, 
            SPAN($HW_STR("helloworld.message")),
            SPAN("&nbsp;"),
            SPAN("$date")
        ),

    onClick: function(event)
    {
        alert("Hello World!");
    }
});

/**
 * Registration
 */
Firebug.registerPanel(HelloWorldPanel); 
Firebug.registerModule(Firebug.HelloWorldModel); 

}});
